"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _Small = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Small"));

var _Alert = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Alert"));

var _P = _interopRequireDefault(require("@bootstrap-styled/v4/lib/P"));

var _A = _interopRequireDefault(require("@bootstrap-styled/v4/lib/A"));

var _H = _interopRequireDefault(require("@bootstrap-styled/v4/lib/H1"));

var _withLoginForm = require("./withLoginForm");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DefaultLoginFormHeader = function DefaultLoginFormHeader(_ref) {
  var logo = _ref.logo,
      version = _ref.version;
  return _react.default.createElement(_react.Fragment, null, _react.default.createElement(_H.default, null, logo), version && _react.default.createElement(_Small.default, {
    color: "muted"
  }, version));
};

var DefaultLoginFormFooter = function DefaultLoginFormFooter() {
  return _react.default.createElement(_Small.default, {
    className: "footer-terms-conditions",
    color: "muted"
  }, "By clicking you agree to the", ' ', _react.default.createElement(_A.default, {
    href: "#"
  }, "Terms & Conditions"), ' ', "and", ' ', _react.default.createElement(_A.default, {
    href: "#"
  }, "Privacy Policy"), ".");
};

var DefaultLoginFormAfterActions = function DefaultLoginFormAfterActions() {
  return _react.default.createElement("div", {
    className: "text-center"
  }, _react.default.createElement(_A.default, {
    href: "#"
  }, "Forgot your username or password?"), _react.default.createElement(_P.default, {
    className: "mt-1"
  }, "Dont have an account?", _react.default.createElement(_A.default, {
    href: "#"
  }, "Sign Up")));
};

var defaultProps = _objectSpread({
  logo: null,
  version: null,
  labelHidden: false,
  rememberMe: false,
  afterActions: _react.default.createElement(DefaultLoginFormAfterActions, null),
  footer: _react.default.createElement(DefaultLoginFormFooter, null),
  loader: 'Loading...',
  autoHideDuration: null,
  onSubmit: function onSubmit() {
    return console.warn('You must set an onSubmit() function to the LoginForm.');
  }
}, _withLoginForm.defaultProps, {
  theme: {
    loginForm: {
      '$wrapper-bg-color': '#E9EAEC',
      '$login-font-size': '15px',
      '$login-wrapper-padding': '2rem 1.25rem',
      '$login-wrapper-bg-color': '#fff',
      '$login-wrapper-width': '25rem',
      '$login-wrapper-border-width': '0px',
      '$login-wrapper-border-color': 'grey',
      '$login-header-wrapper-margin': '0',
      '$login-header-wrapper-border-width': '1px',
      '$login-header-wrapper-border-color': '#D9DADC',
      '$login-header-wrapper-margin-top': '2rem',
      '$login-header-wrapper-margin-bottom': '2rem',
      '$login-header-wrapper-padding-bottom': '2rem',
      '$login-footer-wrapper-border-width': '1px',
      '$login-footer-wrapper-border-color': '#D9DADC',
      '$login-footer-wrapper-margin': '2rem auto',
      '$login-footer-font-size': '.6rem',
      '$checkbox-margin-left': '-8.5rem'
    }
  }
});
/* eslint-disable react/no-unused-prop-types */


exports.defaultProps = defaultProps;
var propTypes = {
  className: _propTypes.default.string.isRequired,

  /** if you have not specified a header component you can directly insert your Logo in the default header provided. */
  logo: _propTypes.default.any,
  version: _propTypes.default.any,
  labelHidden: _propTypes.default.bool,
  notification: _propTypes.default.object,
  hideNotification: _propTypes.default.func,
  rememberMe: _propTypes.default.bool,
  input: _propTypes.default.object,
  meta: _propTypes.default.object,
  header: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.bool]),
  footer: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.bool]),
  loader: _propTypes.default.any,
  onSubmit: _propTypes.default.func,
  loginForm: _propTypes.default.node,
  beforeActions: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.bool]),
  afterActions: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.bool]),
  autoHideDuration: _propTypes.default.number,
  theme: _propTypes.default.object
};
/* eslint-enable react/no-unused-prop-types */

/** @component */

exports.propTypes = propTypes;

var _default = function _default(LoginForm) {
  var FormWrapperUnstyled =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(FormWrapperUnstyled, _React$Component);

    function FormWrapperUnstyled() {
      _classCallCheck(this, FormWrapperUnstyled);

      return _possibleConstructorReturn(this, _getPrototypeOf(FormWrapperUnstyled).apply(this, arguments));
    }

    _createClass(FormWrapperUnstyled, [{
      key: "render",
      // eslint-disable-line react/prefer-stateless-function
      value: function render() {
        var _omit = (0, _lodash.default)(this.props, ['theme']),
            header = _omit.header,
            footer = _omit.footer,
            hideNotification = _omit.hideNotification,
            autoHideDuration = _omit.autoHideDuration,
            labelHidden = _omit.labelHidden,
            notification = _omit.notification,
            loader = _omit.loader,
            logo = _omit.logo,
            version = _omit.version,
            loginForm = _omit.loginForm,
            className = _omit.className,
            beforeActions = _omit.beforeActions,
            afterActions = _omit.afterActions,
            rememberMe = _omit.rememberMe,
            translate = _omit.translate,
            formRest = _objectWithoutProperties(_omit, ["header", "footer", "hideNotification", "autoHideDuration", "labelHidden", "notification", "loader", "logo", "version", "loginForm", "className", "beforeActions", "afterActions", "rememberMe", "translate"]);

        return _react.default.createElement("div", {
          className: (0, _classnames.default)(className, 'main-wrapper')
        }, _react.default.createElement("div", {
          className: (0, _classnames.default)('login-wrapper')
        }, _react.default.createElement("div", {
          className: (0, _classnames.default)('login-header-wrapper d-flex justify-content-center align-items-center flex-column')
        }, header || (0, _react.createElement)(DefaultLoginFormHeader, {
          logo: logo,
          version: version
        })), _react.default.createElement("div", null, loginForm || (0, _react.createElement)(LoginForm, _objectSpread({
          notification: notification && notification.message.length > 0 && _react.default.createElement(_Alert.default, {
            color: notification.type,
            className: "text-center w-100",
            autoHideDuration: notification.autoHideDuration || autoHideDuration,
            onClick: hideNotification
          }, notification.message),
          beforeActions: beforeActions,
          afterActions: afterActions,
          labelHidden: labelHidden,
          rememberMe: rememberMe,
          translate: translate,
          loader: loader
        }, formRest))), _react.default.createElement("div", {
          className: "login-footer-wrapper"
        }, footer)));
      }
    }]);

    return FormWrapperUnstyled;
  }(_react.default.Component);
  /* eslint-disable no-unused-vars */


  _defineProperty(FormWrapperUnstyled, "propTypes", propTypes);

  _defineProperty(FormWrapperUnstyled, "defaultProps", defaultProps);

  var FormWrapper = (0, _styledComponents.default)(FormWrapperUnstyled).withConfig({
    displayName: "withFormWrapper__FormWrapper",
    componentId: "sc-19rtz0r-0"
  })(["", ""], function (props) {
    return "\n      &.main-wrapper {\n        display: flex;\n        flex-direction: column;\n        min-height: 100vh;\n        align-items: center;\n        justify-content: flex-start;\n        background-color: ".concat(props.theme.loginForm['$wrapper-bg-color'], ";\n        font-size: ").concat(props.theme.loginForm['$login-font-size'], ";\n        .login-wrapper {\n          padding: ").concat(props.theme.loginForm['$login-wrapper-padding'], ";\n          background-color: ").concat(props.theme.loginForm['$login-wrapper-bg-color'], ";\n          margin: auto;\n          width: ").concat(props.theme.loginForm['$login-wrapper-width'], ";\n          border: ").concat(props.theme.loginForm['$login-wrapper-border-width'], " solid ").concat(props.theme.loginForm['$login-wrapper-border-color'], ";\n  \n          .login-header-wrapper {\n            margin: ").concat(props.theme.loginForm['$login-header-wrapper-margin'], ";\n            border-bottom: ").concat(props.theme.loginForm['$login-header-wrapper-border-width'], " solid ").concat(props.theme.loginForm['$login-header-wrapper-border-color'], ";\n            margin-top: ").concat(props.theme.loginForm['$login-header-wrapper-margin-top'], ";\n            margin-bottom: ").concat(props.theme.loginForm['$login-header-wrapper-margin-bottom'], ";\n            padding-bottom: ").concat(props.theme.loginForm['$login-header-wrapper-padding-bottom'], ";\n\n          }\n          .login-footer-wrapper {\n            margin: ").concat(props.theme.loginForm['$login-footer-wrapper-margin'], ";\n            border-top: ").concat(props.theme.loginForm['$login-footer-wrapper-border-width'], " solid ").concat(props.theme.loginForm['$login-footer-wrapper-border-color'], ";\n            .footer-terms-conditions {\n              font-size: ").concat(props.theme.loginForm['$login-footer-font-size'], ";\n            }\n          }\n        }\n      }    \n    ");
  });
  /* eslint-enable no-unused-vars */

  FormWrapper.defaultProps = defaultProps;
  return FormWrapper;
};

exports.default = _default;