"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Label = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Label"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var _Button = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Button"));

var _Form = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form"));

var _FormGroup = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormGroup"));

var _FormFeedback = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form/FormFeedback"));

var _breakpoints = _interopRequireDefault(require("@bootstrap-styled/css-mixins/lib/breakpoints"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var defaultProps = {
  beforeActions: null,
  isLoading: null,
  rememberMe: false,
  initialValues: {
    username: '',
    password: ''
  },
  placeHolder: {
    username: 'Santaclauze',
    password: '••••••••••'
  },
  theme: {
    loginForm: {
      '$wrapper-bg-color': '#E9EAEC',
      '$login-font-size': '15px',
      '$login-wrapper-padding': '2rem 1.25rem',
      '$login-wrapper-bg-color': '#fff',
      '$login-wrapper-width': '25rem',
      '$login-wrapper-border-width': '0px',
      '$login-wrapper-border-color': 'grey',
      '$login-header-wrapper-margin': '0',
      '$login-footer-wrapper-margin': '1rem auto',
      '$login-footer-font-size': '.6rem',
      '$checkbox-margin-left': '-8.5rem'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  beforeActions: _propTypes.default.node,
  afterActions: _propTypes.default.node,
  className: _propTypes.default.string.isRequired,
  onSubmit: _propTypes.default.func.isRequired,
  isLoading: _propTypes.default.bool,
  labelHidden: _propTypes.default.bool,
  rememberMe: _propTypes.default.bool,
  loader: _propTypes.default.node,
  initialValues: _propTypes.default.shape({
    username: _propTypes.default.string,
    password: _propTypes.default.string
  }),
  placeHolder: _propTypes.default.shape({
    username: _propTypes.default.string,
    password: _propTypes.default.string
  }),
  theme: _propTypes.default.object,
  translate: _propTypes.default.func
};
exports.propTypes = propTypes;

var sanitizeRestProps = function sanitizeRestProps(_ref) {
  var anyTouched = _ref.anyTouched,
      array = _ref.array,
      asyncValidate = _ref.asyncValidate,
      asyncValidating = _ref.asyncValidating,
      autofill = _ref.autofill,
      blur = _ref.blur,
      change = _ref.change,
      clearAsyncError = _ref.clearAsyncError,
      clearFields = _ref.clearFields,
      clearSubmit = _ref.clearSubmit,
      clearSubmitErrors = _ref.clearSubmitErrors,
      destroy = _ref.destroy,
      dirty = _ref.dirty,
      dispatch = _ref.dispatch,
      form = _ref.form,
      handleSubmit = _ref.handleSubmit,
      initialize = _ref.initialize,
      initialized = _ref.initialized,
      initialValues = _ref.initialValues,
      pristine = _ref.pristine,
      pure = _ref.pure,
      redirect = _ref.redirect,
      reset = _ref.reset,
      resetSection = _ref.resetSection,
      save = _ref.save,
      submit = _ref.submit,
      submitFailed = _ref.submitFailed,
      submitSucceeded = _ref.submitSucceeded,
      submitting = _ref.submitting,
      touch = _ref.touch,
      translate = _ref.translate,
      triggerSubmit = _ref.triggerSubmit,
      untouch = _ref.untouch,
      valid = _ref.valid,
      validate = _ref.validate,
      invalid = _ref.invalid,
      props = _objectWithoutProperties(_ref, ["anyTouched", "array", "asyncValidate", "asyncValidating", "autofill", "blur", "change", "clearAsyncError", "clearFields", "clearSubmit", "clearSubmitErrors", "destroy", "dirty", "dispatch", "form", "handleSubmit", "initialize", "initialized", "initialValues", "pristine", "pure", "redirect", "reset", "resetSection", "save", "submit", "submitFailed", "submitSucceeded", "submitting", "touch", "translate", "triggerSubmit", "untouch", "valid", "validate", "invalid"]);

  return props;
}; // see http://redux-form.com/6.4.3/examples/material-ui/


var renderInput = function renderInput(_ref2) {
  var _ref2$meta = _ref2.meta;
  _ref2$meta = _ref2$meta === void 0 ? {} : _ref2$meta;

  var touched = _ref2$meta.touched,
      error = _ref2$meta.error,
      inputProps = _ref2.input,
      labelHidden = _ref2.labelHidden,
      translate = _ref2.translate,
      label = _ref2.label,
      type = _ref2.type,
      _ref2$labelProps = _ref2.labelProps,
      labelProps = _ref2$labelProps === void 0 ? {} : _ref2$labelProps,
      props = _objectWithoutProperties(_ref2, ["meta", "input", "labelHidden", "translate", "label", "type", "labelProps"]);

  return _react.default.createElement(_FormGroup.default, {
    color: touched && error ? 'danger' : ''
  }, type === 'checkbox' ? _react.default.createElement(_react.Fragment, null, _react.default.createElement(_Label.default, _extends({}, labelProps, {
    hidden: labelHidden
  }), _react.default.createElement(_Input.default, _extends({}, inputProps, props, {
    type: type
  })), label)) : _react.default.createElement(_react.Fragment, null, _react.default.createElement(_Label.default, _extends({}, labelProps, {
    hidden: labelHidden
  }), label), _react.default.createElement(_Input.default, _extends({}, inputProps, {
    type: type
  }, props))), !!(touched && error) && _react.default.createElement(_FormFeedback.default, null, translate ? translate(error) : error));
};
/** @component */


var _default = function _default(Field) {
  var LoginFormUnstyled = function LoginFormUnstyled(props) {
    var _omit = (0, _lodash.default)(props, ['theme']),
        className = _omit.className,
        placeHolder = _omit.placeHolder,
        beforeActions = _omit.beforeActions,
        afterActions = _omit.afterActions,
        notification = _omit.notification,
        isLoading = _omit.isLoading,
        labelHidden = _omit.labelHidden,
        rememberMe = _omit.rememberMe,
        handleSubmit = _omit.handleSubmit,
        onSubmit = _omit.onSubmit,
        submitting = _omit.submitting,
        translate = _omit.translate,
        loader = _omit.loader,
        rest = _objectWithoutProperties(_omit, ["className", "placeHolder", "beforeActions", "afterActions", "notification", "isLoading", "labelHidden", "rememberMe", "handleSubmit", "onSubmit", "submitting", "translate", "loader"]);

    return _react.default.createElement(_Form.default, _extends({
      name: "login-form",
      className: (0, _classnames.default)('form', className),
      onSubmit: handleSubmit ? handleSubmit(onSubmit) : onSubmit
    }, sanitizeRestProps(rest)), notification, _react.default.createElement("div", {
      className: "field-wrapper"
    }, Field ? _react.default.createElement(Field, {
      name: "username",
      label: translate ? translate('kopax.common.form.label.username') : 'kopax.common.form.label.username',
      type: "text",
      placeholder: placeHolder.username,
      disabled: isLoading,
      component: renderInput,
      labelHidden: labelHidden,
      translate: translate
    }) : (0, _react.createElement)(renderInput, {
      label: 'Username',
      placeholder: placeHolder.username,
      labelHidden: labelHidden
    })), _react.default.createElement("div", {
      className: "field-wrapper"
    }, Field ? _react.default.createElement(Field, {
      name: "password",
      label: translate ? translate('kopax.common.form.label.password') : 'kopax.common.form.label.password',
      type: "password",
      placeholder: placeHolder.password,
      disabled: isLoading,
      component: renderInput,
      labelHidden: labelHidden,
      translate: translate
    }) : (0, _react.createElement)(renderInput, {
      label: 'Password',
      placeholder: placeHolder.password,
      labelHidden: labelHidden
    })), beforeActions, _react.default.createElement("div", {
      className: "action-wrapper d-flex flex-column flex-md-row justify-content-around align-items-md-center py-3 my-3"
    }, rememberMe ? Field ? // eslint-disable-line no-nested-ternary
    _react.default.createElement(Field, {
      name: "rememberMe",
      label: translate ? translate('kopax.common.form.label.rememberMe') : 'kopax.common.form.label.rememberMe',
      type: "checkbox",
      disabled: isLoading,
      component: renderInput,
      translate: translate
    }) : _react.default.createElement(_FormGroup.default, {
      className: "mb-0"
    }, _react.default.createElement(_Label.default, {
      check: true
    }, 'Remember me', _react.default.createElement(_Input.default, {
      type: "checkbox"
    }))) : null, _react.default.createElement(_Button.default, {
      type: "submit",
      disabled: isLoading || submitting,
      color: "primary"
    }, !(isLoading || submitting) ? translate ? translate('kopax.common.form.button.login') : 'kopax.common.form.button.login' : loader
    /* eslint-disable-line */
    )), afterActions);
  };

  LoginFormUnstyled.propTypes = propTypes;
  var LoginForm = (0, _styledComponents.default)(LoginFormUnstyled).withConfig({
    displayName: "withLoginForm__LoginForm",
    componentId: "ty81t3-0"
  })(["", ""], function (props) {
    return "\n      .action-wrapper {  \n        .btn {\n          width: 100%;\n          ".concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], 'width: 50%'), "\n        }\n        .form-check-input {\n          margin-left: ").concat(props.theme.loginForm['$checkbox-margin-left'], ";\n        }\n      }\n    ");
  });
  LoginForm.defaultProps = defaultProps;
  return LoginForm;
};

exports.default = _default;